#include <stdio.h>
#include <string.h>
#include "geometry.h"
#include "pointLight.h"
#include "math.h"
#include "implemented.h"

int PointLight::read(FILE* fp){
  if(fscanf(fp," %lg %lg %lg %lg %lg %lg %lg %lg %lg", 
	    &(color[0]),&(color[1]),&(color[2]),
	    &(location[0]),&(location[1]),&(location[2]),
	    &(constAtten),&(linearAtten),&(quadAtten)) != 9){return 0;}
  return 1;
}
void PointLight::write(FILE* fp){
  fprintf(fp,"#light_point\n");
  fprintf(fp,"  %lg %lg %lg\n",color[0],color[1],color[2]);
  fprintf(fp,"  %lg %lg %lg\n",location[0],location[1],location[2]);
  fprintf(fp,"  %lg %lg %lg\n",constAtten,linearAtten,quadAtten);
}
Point3D PointLight::getDiffuse(Point3D cameraPosition,IntersectionInfo iInfo){
  if(implementedFlag){
    printf("The PointLight::getDiffuse(Point3D cameraPosition,IntersectionInfo iInfo) method has not been implemented\n");
  }
  return Point3D();
}
Point3D PointLight::getSpecular(Point3D cameraPosition,IntersectionInfo iInfo){
  if(implementedFlag){
    printf("The PointLight::getSpecular(Point3D cameraPosition,IntersectionInfo iInfo) method has not been implemented\n");
  }
  return Point3D();
}
int PointLight::isInShadow(IntersectionInfo iInfo,Shape* shape){
  if(implementedFlag){
    printf("The PointLight::isInShadow(IntersectionInfo iInfo,Shape* shape) method has not been implemented\n");
  }
  return 0;
}

