#include <stdio.h>
#include <string.h>
#include "geometry.h"
#include "spotLight.h"
#include "math.h"
#include "implemented.h"

int SpotLight::read(FILE* fp){
  if (fscanf(fp," %lg %lg %lg %lg %lg %lg %lg %lg %lg %lg %lg %lg %lg %lg", 
	     &(color[0]),&(color[1]),&(color[2]),
	     &(location[0]),&(location[1]),&(location[2]),
	     &(direction[0]),&(direction[1]),&(direction[2]),
	     &(constAtten),&(linearAtten),&(quadAtten),
	     &(cutOffAngle),&(dropOffRate)) != 14){return 0;}
  direction=direction.unit();
  return 1;
}
void SpotLight::write(FILE* fp){
  fprintf(fp,"#light_spot\n");
  fprintf(fp,"  %lg %lg %lg\n",color[0],color[1],color[2]);
  fprintf(fp,"  %lg %lg %lg\n",location[0],location[1],location[2]);
  fprintf(fp,"  %lg %lg %lg\n",direction[0],direction[1],direction[2]);
  fprintf(fp,"  %lg %lg %lg\n",constAtten,linearAtten,quadAtten);
  fprintf(fp,"  %lg %lg\n",cutOffAngle,dropOffRate);
}
Point3D SpotLight::getDiffuse(Point3D cameraPosition,IntersectionInfo iInfo){
  if(implementedFlag){
    printf("The SpotLight::getDiffuse(Point3D cameraPosition,IntersectionInfo iInfo) method has not been implemented\n");
  }
  return Point3D();
}
Point3D SpotLight::getSpecular(Point3D cameraPosition,IntersectionInfo iInfo){
  if(implementedFlag){
    printf("The SpotLight::getSpecular(Point3D cameraPosition,IntersecitonInfo iInfo) method has not been implemented\n");
  }
  return Point3D();
}
int SpotLight::isInShadow(IntersectionInfo iInfo,Shape* shape){
  if(implementedFlag){
    printf("The SpotLight::isInShadow(IntersecitonInfo iInfo,Shape* shape) method has not been implemented\n");
  }
  return 0;
}

